diff --git a/main/config.c b/main/config.c
index 4766d2e..53153ff 100644
--- a/main/config.c
+++ b/main/config.c
@@ -2162,7 +2162,7 @@ int ast_config_text_file_save(const char *configfile, const struct ast_config *c
 
 	/* now make sure we have write access to the main config file */
 	make_fn(fn, sizeof(fn), 0, configfile);
-	if (access(fn, R_OK | W_OK)) {
+	if (!access(fn, F_OK) && access(fn, R_OK | W_OK)) {
 		ast_log(LOG_ERROR, "Unable to write %s (%s)\n", fn, strerror(errno));
 		return -1;
 	}
